package com.nisum.employeeservice.service;

import com.nisum.employeeservice.model.Employee;
import com.nisum.employeeservice.repository.EmployeeRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

@Service
public class EmployeeService {

  @Autowired EmployeeRepository employeeRepository;


  public List<Employee> findAllEmployees() {
    /*some business*/
    return employeeRepository.findAll();
  }

  public Optional<Employee> findEmployeeById(Long id) {
    return employeeRepository.findById(id);
  }

  public Employee addEmployee(Employee employee) {
    return employeeRepository.save(employee);
  }

  public Employee updateEmployee(Long id, Employee updatedEmployee) {
    Employee staleEmployee = employeeRepository.findById(id)
            .orElse(null);
    if (staleEmployee == null) {
      return null;
    }

    if (updatedEmployee.getFirstName() != null && !updatedEmployee.getFirstName().equals(staleEmployee.getFirstName())) {
      staleEmployee.setFirstName(updatedEmployee.getFirstName());
    }

    if (updatedEmployee.getLastName() != null &&!updatedEmployee.getLastName().equals(staleEmployee.getFirstName())) {
      staleEmployee.setLastName(updatedEmployee.getLastName());
    }

    employeeRepository.save(staleEmployee);
    return staleEmployee;
  }

  public void deleteEmployee(Employee employee) {
    employeeRepository.delete(employee);
  }
}
